import{S as El,i as Pl,s as xl,e as l,k as u,w as h,t as s,M as Tl,c as r,d as a,m as d,a as i,x as _,h as o,b as m,G as t,g as p,y as c,q as f,o as g,B as b,v as zl}from"../../chunks/vendor-hf-doc-builder.js";import{T as Cl}from"../../chunks/Tip-hf-doc-builder.js";import{I as Re}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as y}from"../../chunks/CodeBlock-hf-doc-builder.js";import{D as Al}from"../../chunks/DocNotebookDropdown-hf-doc-builder.js";function Ll(Bt){let k,X,w,z,U;return{c(){k=l("p"),X=s("\u{1F4A1} Read "),w=l("a"),z=s("The Power of Scale for Parameter-Efficient Prompt Tuning"),U=s(" to learn more about prompt tuning."),this.h()},l(T){k=r(T,"P",{});var L=i(k);X=o(L,"\u{1F4A1} Read "),w=r(L,"A",{href:!0,rel:!0});var J=i(w);z=o(J,"The Power of Scale for Parameter-Efficient Prompt Tuning"),J.forEach(a),U=o(L," to learn more about prompt tuning."),L.forEach(a),this.h()},h(){m(w,"href","https://arxiv.org/abs/2104.08691"),m(w,"rel","nofollow")},m(T,L){p(T,k,L),t(k,X),t(k,w),t(w,z),t(k,U)},d(T){T&&a(k)}}}function Ml(Bt){let k,X,w,z,U,T,L,J,Qa,Wt,re,Xt,He,Va,Jt,K,Kt,C,Za,ie,it,es,ts,pt,as,ss,pe,os,ns,Qt,Ge,ls,Vt,ue,Zt,F,Q,ut,de,rs,dt,is,ea,M,ps,Ye,us,ds,Be,ms,hs,ta,me,aa,R,V,mt,he,_s,ht,cs,sa,j,fs,_t,gs,bs,_e,ks,vs,ct,ws,$s,ft,ys,js,oa,ce,na,q,qs,gt,Es,Ps,bt,xs,Ts,kt,zs,Cs,fe,As,Ls,la,ge,ra,H,Z,vt,be,Ms,wt,Ds,ia,We,Ss,pa,ke,ua,ee,Ns,$t,Os,Is,da,E,yt,Us,Fs,ve,Rs,jt,Hs,Gs,Ys,we,Bs,qt,Ws,Xs,Js,G,Ks,Et,Qs,Vs,Pt,Zs,eo,to,$e,ao,xt,so,oo,ma,ye,ha,D,no,je,lo,ro,Tt,io,po,_a,qe,ca,P,uo,Ee,zt,mo,ho,Ct,_o,co,At,fo,go,Lt,bo,ko,fa,Pe,ga,Y,te,Mt,xe,vo,Dt,wo,ba,Xe,$o,ka,$,yo,Te,jo,qo,St,Eo,Po,Nt,xo,To,Je,zo,Co,Ke,Ao,Lo,va,ze,wa,Qe,Mo,$a,Ce,ya,Ve,Do,ja,Ae,qa,B,ae,Ot,Le,So,It,No,Ea,Ze,Oo,Pa,Me,xa,se,Io,De,Uo,Fo,Ta,Se,za,et,Ro,Ca,W,oe,Ut,Ne,Ho,Ft,Go,Aa,v,Yo,Rt,Bo,Wo,tt,Xo,Jo,Ht,Ko,Qo,Gt,Vo,Zo,at,en,tn,st,an,sn,La,Oe,Ma,ot,on,Da,Ie,Sa,ne,nn,Yt,ln,rn,Na,Ue,Oa;return T=new Re({}),re=new Al({props:{classNames:"absolute z-10 right-0 top-0",options:[{label:"Mixed",value:"https://colab.research.google.com/github/huggingface/notebooks/blob/main/peft_doc/en/clm-prompt-tuning.ipynb"},{label:"PyTorch",value:"https://colab.research.google.com/github/huggingface/notebooks/blob/main/peft_doc/en/pytorch/clm-prompt-tuning.ipynb"},{label:"TensorFlow",value:"https://colab.research.google.com/github/huggingface/notebooks/blob/main/peft_doc/en/tensorflow/clm-prompt-tuning.ipynb"},{label:"Mixed",value:"https://studiolab.sagemaker.aws/import/github/huggingface/notebooks/blob/main/peft_doc/en/clm-prompt-tuning.ipynb"},{label:"PyTorch",value:"https://studiolab.sagemaker.aws/import/github/huggingface/notebooks/blob/main/peft_doc/en/pytorch/clm-prompt-tuning.ipynb"},{label:"TensorFlow",value:"https://studiolab.sagemaker.aws/import/github/huggingface/notebooks/blob/main/peft_doc/en/tensorflow/clm-prompt-tuning.ipynb"}]}}),K=new Cl({props:{$$slots:{default:[Ll]},$$scope:{ctx:Bt}}}),ue=new y({props:{code:"!pip install -q peft transformers datasets",highlighted:"!pip install -q peft transformers datasets"}}),de=new Re({}),me=new y({props:{code:`from transformers import AutoModelForCausalLM, AutoTokenizer, default_data_collator, get_linear_schedule_with_warmup
from peft import get_peft_config, get_peft_model, PromptTuningInit, PromptTuningConfig, TaskType, PeftType
import torch
from datasets import load_dataset
import os
from torch.utils.data import DataLoader
from tqdm import tqdm

device = "cuda"
model_name_or_path = "bigscience/bloomz-560m"
tokenizer_name_or_path = "bigscience/bloomz-560m"
peft_config = PromptTuningConfig(
    task_type=TaskType.CAUSAL_LM,
    prompt_tuning_init=PromptTuningInit.TEXT,
    num_virtual_tokens=8,
    prompt_tuning_init_text="Classify if the tweet is a complaint or not:",
    tokenizer_name_or_path=model_name_or_path,
)

dataset_name = "twitter_complaints"
checkpoint_name = f"{dataset_name}_{model_name_or_path}_{peft_config.peft_type}_{peft_config.task_type}_v1.pt".replace(
    "/", "_"
)
text_column = "Tweet text"
label_column = "text_label"
max_length = 64
lr = 3e-2
num_epochs = 50
batch_size = 8`,highlighted:`<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoModelForCausalLM, AutoTokenizer, default_data_collator, get_linear_schedule_with_warmup
<span class="hljs-keyword">from</span> peft <span class="hljs-keyword">import</span> get_peft_config, get_peft_model, PromptTuningInit, PromptTuningConfig, TaskType, PeftType
<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset
<span class="hljs-keyword">import</span> os
<span class="hljs-keyword">from</span> torch.utils.data <span class="hljs-keyword">import</span> DataLoader
<span class="hljs-keyword">from</span> tqdm <span class="hljs-keyword">import</span> tqdm

device = <span class="hljs-string">&quot;cuda&quot;</span>
model_name_or_path = <span class="hljs-string">&quot;bigscience/bloomz-560m&quot;</span>
tokenizer_name_or_path = <span class="hljs-string">&quot;bigscience/bloomz-560m&quot;</span>
peft_config = PromptTuningConfig(
    task_type=TaskType.CAUSAL_LM,
    prompt_tuning_init=PromptTuningInit.TEXT,
    num_virtual_tokens=<span class="hljs-number">8</span>,
    prompt_tuning_init_text=<span class="hljs-string">&quot;Classify if the tweet is a complaint or not:&quot;</span>,
    tokenizer_name_or_path=model_name_or_path,
)

dataset_name = <span class="hljs-string">&quot;twitter_complaints&quot;</span>
checkpoint_name = <span class="hljs-string">f&quot;<span class="hljs-subst">{dataset_name}</span>_<span class="hljs-subst">{model_name_or_path}</span>_<span class="hljs-subst">{peft_config.peft_type}</span>_<span class="hljs-subst">{peft_config.task_type}</span>_v1.pt&quot;</span>.replace(
    <span class="hljs-string">&quot;/&quot;</span>, <span class="hljs-string">&quot;_&quot;</span>
)
text_column = <span class="hljs-string">&quot;Tweet text&quot;</span>
label_column = <span class="hljs-string">&quot;text_label&quot;</span>
max_length = <span class="hljs-number">64</span>
lr = <span class="hljs-number">3e-2</span>
num_epochs = <span class="hljs-number">50</span>
batch_size = <span class="hljs-number">8</span>`}}),he=new Re({}),ce=new y({props:{code:`dataset = load_dataset("ought/raft", dataset_name)
dataset["train"][0]
{"Tweet text": "@HMRCcustomers No this is my first job", "ID": 0, "Label": 2}`,highlighted:`dataset = load_dataset(<span class="hljs-string">&quot;ought/raft&quot;</span>, dataset_name)
dataset[<span class="hljs-string">&quot;train&quot;</span>][<span class="hljs-number">0</span>]
{<span class="hljs-string">&quot;Tweet text&quot;</span>: <span class="hljs-string">&quot;@HMRCcustomers No this is my first job&quot;</span>, <span class="hljs-string">&quot;ID&quot;</span>: <span class="hljs-number">0</span>, <span class="hljs-string">&quot;Label&quot;</span>: <span class="hljs-number">2</span>}`}}),ge=new y({props:{code:`classes = [k.replace("_", " ") for k in dataset["train"].features["Label"].names]
dataset = dataset.map(
    lambda x: {"text_label": [classes[label] for label in x["Label"]]},
    batched=True,
    num_proc=1,
)
{"Tweet text": "@HMRCcustomers No this is my first job", "ID": 0, "Label": 2, "text_label": "no complaint"}`,highlighted:`classes = [k.replace(<span class="hljs-string">&quot;_&quot;</span>, <span class="hljs-string">&quot; &quot;</span>) <span class="hljs-keyword">for</span> k <span class="hljs-keyword">in</span> dataset[<span class="hljs-string">&quot;train&quot;</span>].features[<span class="hljs-string">&quot;Label&quot;</span>].names]
dataset = dataset.<span class="hljs-built_in">map</span>(
    <span class="hljs-keyword">lambda</span> x: {<span class="hljs-string">&quot;text_label&quot;</span>: [classes[label] <span class="hljs-keyword">for</span> label <span class="hljs-keyword">in</span> x[<span class="hljs-string">&quot;Label&quot;</span>]]},
    batched=<span class="hljs-literal">True</span>,
    num_proc=<span class="hljs-number">1</span>,
)
{<span class="hljs-string">&quot;Tweet text&quot;</span>: <span class="hljs-string">&quot;@HMRCcustomers No this is my first job&quot;</span>, <span class="hljs-string">&quot;ID&quot;</span>: <span class="hljs-number">0</span>, <span class="hljs-string">&quot;Label&quot;</span>: <span class="hljs-number">2</span>, <span class="hljs-string">&quot;text_label&quot;</span>: <span class="hljs-string">&quot;no complaint&quot;</span>}`}}),be=new Re({}),ke=new y({props:{code:`tokenizer = AutoTokenizer.from_pretrained(model_name_or_path)
if tokenizer.pad_token_id is None:
    tokenizer.pad_token_id = tokenizer.eos_token_id
target_max_length = max([len(tokenizer(class_label)["input_ids"]) for class_label in classes])
print(target_max_length)
3`,highlighted:`tokenizer = AutoTokenizer.from_pretrained(model_name_or_path)
<span class="hljs-keyword">if</span> tokenizer.pad_token_id <span class="hljs-keyword">is</span> <span class="hljs-literal">None</span>:
    tokenizer.pad_token_id = tokenizer.eos_token_id
target_max_length = <span class="hljs-built_in">max</span>([<span class="hljs-built_in">len</span>(tokenizer(class_label)[<span class="hljs-string">&quot;input_ids&quot;</span>]) <span class="hljs-keyword">for</span> class_label <span class="hljs-keyword">in</span> classes])
<span class="hljs-built_in">print</span>(target_max_length)
<span class="hljs-number">3</span>`}}),ye=new y({props:{code:`def preprocess_function(examples):
    batch_size = len(examples[text_column])
    inputs = [f"{text_column} : {x} Label : " for x in examples[text_column]]
    targets = [str(x) for x in examples[label_column]]
    model_inputs = tokenizer(inputs)
    labels = tokenizer(targets)
    for i in range(batch_size):
        sample_input_ids = model_inputs["input_ids"][i]
        label_input_ids = labels["input_ids"][i] + [tokenizer.pad_token_id]
        # print(i, sample_input_ids, label_input_ids)
        model_inputs["input_ids"][i] = sample_input_ids + label_input_ids
        labels["input_ids"][i] = [-100] * len(sample_input_ids) + label_input_ids
        model_inputs["attention_mask"][i] = [1] * len(model_inputs["input_ids"][i])
    # print(model_inputs)
    for i in range(batch_size):
        sample_input_ids = model_inputs["input_ids"][i]
        label_input_ids = labels["input_ids"][i]
        model_inputs["input_ids"][i] = [tokenizer.pad_token_id] * (
            max_length - len(sample_input_ids)
        ) + sample_input_ids
        model_inputs["attention_mask"][i] = [0] * (max_length - len(sample_input_ids)) + model_inputs[
            "attention_mask"
        ][i]
        labels["input_ids"][i] = [-100] * (max_length - len(sample_input_ids)) + label_input_ids
        model_inputs["input_ids"][i] = torch.tensor(model_inputs["input_ids"][i][:max_length])
        model_inputs["attention_mask"][i] = torch.tensor(model_inputs["attention_mask"][i][:max_length])
        labels["input_ids"][i] = torch.tensor(labels["input_ids"][i][:max_length])
    model_inputs["labels"] = labels["input_ids"]
    return model_inputs`,highlighted:`<span class="hljs-keyword">def</span> <span class="hljs-title function_">preprocess_function</span>(<span class="hljs-params">examples</span>):
    batch_size = <span class="hljs-built_in">len</span>(examples[text_column])
    inputs = [<span class="hljs-string">f&quot;<span class="hljs-subst">{text_column}</span> : <span class="hljs-subst">{x}</span> Label : &quot;</span> <span class="hljs-keyword">for</span> x <span class="hljs-keyword">in</span> examples[text_column]]
    targets = [<span class="hljs-built_in">str</span>(x) <span class="hljs-keyword">for</span> x <span class="hljs-keyword">in</span> examples[label_column]]
    model_inputs = tokenizer(inputs)
    labels = tokenizer(targets)
    <span class="hljs-keyword">for</span> i <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(batch_size):
        sample_input_ids = model_inputs[<span class="hljs-string">&quot;input_ids&quot;</span>][i]
        label_input_ids = labels[<span class="hljs-string">&quot;input_ids&quot;</span>][i] + [tokenizer.pad_token_id]
        <span class="hljs-comment"># print(i, sample_input_ids, label_input_ids)</span>
        model_inputs[<span class="hljs-string">&quot;input_ids&quot;</span>][i] = sample_input_ids + label_input_ids
        labels[<span class="hljs-string">&quot;input_ids&quot;</span>][i] = [-<span class="hljs-number">100</span>] * <span class="hljs-built_in">len</span>(sample_input_ids) + label_input_ids
        model_inputs[<span class="hljs-string">&quot;attention_mask&quot;</span>][i] = [<span class="hljs-number">1</span>] * <span class="hljs-built_in">len</span>(model_inputs[<span class="hljs-string">&quot;input_ids&quot;</span>][i])
    <span class="hljs-comment"># print(model_inputs)</span>
    <span class="hljs-keyword">for</span> i <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(batch_size):
        sample_input_ids = model_inputs[<span class="hljs-string">&quot;input_ids&quot;</span>][i]
        label_input_ids = labels[<span class="hljs-string">&quot;input_ids&quot;</span>][i]
        model_inputs[<span class="hljs-string">&quot;input_ids&quot;</span>][i] = [tokenizer.pad_token_id] * (
            max_length - <span class="hljs-built_in">len</span>(sample_input_ids)
        ) + sample_input_ids
        model_inputs[<span class="hljs-string">&quot;attention_mask&quot;</span>][i] = [<span class="hljs-number">0</span>] * (max_length - <span class="hljs-built_in">len</span>(sample_input_ids)) + model_inputs[
            <span class="hljs-string">&quot;attention_mask&quot;</span>
        ][i]
        labels[<span class="hljs-string">&quot;input_ids&quot;</span>][i] = [-<span class="hljs-number">100</span>] * (max_length - <span class="hljs-built_in">len</span>(sample_input_ids)) + label_input_ids
        model_inputs[<span class="hljs-string">&quot;input_ids&quot;</span>][i] = torch.tensor(model_inputs[<span class="hljs-string">&quot;input_ids&quot;</span>][i][:max_length])
        model_inputs[<span class="hljs-string">&quot;attention_mask&quot;</span>][i] = torch.tensor(model_inputs[<span class="hljs-string">&quot;attention_mask&quot;</span>][i][:max_length])
        labels[<span class="hljs-string">&quot;input_ids&quot;</span>][i] = torch.tensor(labels[<span class="hljs-string">&quot;input_ids&quot;</span>][i][:max_length])
    model_inputs[<span class="hljs-string">&quot;labels&quot;</span>] = labels[<span class="hljs-string">&quot;input_ids&quot;</span>]
    <span class="hljs-keyword">return</span> model_inputs`}}),qe=new y({props:{code:`processed_datasets = dataset.map(
    preprocess_function,
    batched=True,
    num_proc=1,
    remove_columns=dataset["train"].column_names,
    load_from_cache_file=False,
    desc="Running tokenizer on dataset",
)`,highlighted:`processed_datasets = dataset.<span class="hljs-built_in">map</span>(
    preprocess_function,
    batched=<span class="hljs-literal">True</span>,
    num_proc=<span class="hljs-number">1</span>,
    remove_columns=dataset[<span class="hljs-string">&quot;train&quot;</span>].column_names,
    load_from_cache_file=<span class="hljs-literal">False</span>,
    desc=<span class="hljs-string">&quot;Running tokenizer on dataset&quot;</span>,
)`}}),Pe=new y({props:{code:`train_dataset = processed_datasets["train"]
eval_dataset = processed_datasets["train"]


train_dataloader = DataLoader(
    train_dataset, shuffle=True, collate_fn=default_data_collator, batch_size=batch_size, pin_memory=True
)
eval_dataloader = DataLoader(eval_dataset, collate_fn=default_data_collator, batch_size=batch_size, pin_memory=True)`,highlighted:`train_dataset = processed_datasets[<span class="hljs-string">&quot;train&quot;</span>]
eval_dataset = processed_datasets[<span class="hljs-string">&quot;train&quot;</span>]


train_dataloader = DataLoader(
    train_dataset, shuffle=<span class="hljs-literal">True</span>, collate_fn=default_data_collator, batch_size=batch_size, pin_memory=<span class="hljs-literal">True</span>
)
eval_dataloader = DataLoader(eval_dataset, collate_fn=default_data_collator, batch_size=batch_size, pin_memory=<span class="hljs-literal">True</span>)`}}),xe=new Re({}),ze=new y({props:{code:`model = AutoModelForCausalLM.from_pretrained(model_name_or_path)
model = get_peft_model(model, peft_config)
print(model.print_trainable_parameters())
"trainable params: 8192 || all params: 559222784 || trainable%: 0.0014648902430985358"`,highlighted:`model = AutoModelForCausalLM.from_pretrained(model_name_or_path)
model = get_peft_model(model, peft_config)
<span class="hljs-built_in">print</span>(model.print_trainable_parameters())
<span class="hljs-string">&quot;trainable params: 8192 || all params: 559222784 || trainable%: 0.0014648902430985358&quot;</span>`}}),Ce=new y({props:{code:`optimizer = torch.optim.AdamW(model.parameters(), lr=lr)
lr_scheduler = get_linear_schedule_with_warmup(
    optimizer=optimizer,
    num_warmup_steps=0,
    num_training_steps=(len(train_dataloader) * num_epochs),
)`,highlighted:`optimizer = torch.optim.AdamW(model.parameters(), lr=lr)
lr_scheduler = get_linear_schedule_with_warmup(
    optimizer=optimizer,
    num_warmup_steps=<span class="hljs-number">0</span>,
    num_training_steps=(<span class="hljs-built_in">len</span>(train_dataloader) * num_epochs),
)`}}),Ae=new y({props:{code:`model = model.to(device)

for epoch in range(num_epochs):
    model.train()
    total_loss = 0
    for step, batch in enumerate(tqdm(train_dataloader)):
        batch = {k: v.to(device) for k, v in batch.items()}
        outputs = model(**batch)
        loss = outputs.loss
        total_loss += loss.detach().float()
        loss.backward()
        optimizer.step()
        lr_scheduler.step()
        optimizer.zero_grad()

    model.eval()
    eval_loss = 0
    eval_preds = []
    for step, batch in enumerate(tqdm(eval_dataloader)):
        batch = {k: v.to(device) for k, v in batch.items()}
        with torch.no_grad():
            outputs = model(**batch)
        loss = outputs.loss
        eval_loss += loss.detach().float()
        eval_preds.extend(
            tokenizer.batch_decode(torch.argmax(outputs.logits, -1).detach().cpu().numpy(), skip_special_tokens=True)
        )

    eval_epoch_loss = eval_loss / len(eval_dataloader)
    eval_ppl = torch.exp(eval_epoch_loss)
    train_epoch_loss = total_loss / len(train_dataloader)
    train_ppl = torch.exp(train_epoch_loss)
    print(f"{epoch=}: {train_ppl=} {train_epoch_loss=} {eval_ppl=} {eval_epoch_loss=}")`,highlighted:`model = model.to(device)

<span class="hljs-keyword">for</span> epoch <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(num_epochs):
    model.train()
    total_loss = <span class="hljs-number">0</span>
    <span class="hljs-keyword">for</span> step, batch <span class="hljs-keyword">in</span> <span class="hljs-built_in">enumerate</span>(tqdm(train_dataloader)):
        batch = {k: v.to(device) <span class="hljs-keyword">for</span> k, v <span class="hljs-keyword">in</span> batch.items()}
        outputs = model(**batch)
        loss = outputs.loss
        total_loss += loss.detach().<span class="hljs-built_in">float</span>()
        loss.backward()
        optimizer.step()
        lr_scheduler.step()
        optimizer.zero_grad()

    model.<span class="hljs-built_in">eval</span>()
    eval_loss = <span class="hljs-number">0</span>
    eval_preds = []
    <span class="hljs-keyword">for</span> step, batch <span class="hljs-keyword">in</span> <span class="hljs-built_in">enumerate</span>(tqdm(eval_dataloader)):
        batch = {k: v.to(device) <span class="hljs-keyword">for</span> k, v <span class="hljs-keyword">in</span> batch.items()}
        <span class="hljs-keyword">with</span> torch.no_grad():
            outputs = model(**batch)
        loss = outputs.loss
        eval_loss += loss.detach().<span class="hljs-built_in">float</span>()
        eval_preds.extend(
            tokenizer.batch_decode(torch.argmax(outputs.logits, -<span class="hljs-number">1</span>).detach().cpu().numpy(), skip_special_tokens=<span class="hljs-literal">True</span>)
        )

    eval_epoch_loss = eval_loss / <span class="hljs-built_in">len</span>(eval_dataloader)
    eval_ppl = torch.exp(eval_epoch_loss)
    train_epoch_loss = total_loss / <span class="hljs-built_in">len</span>(train_dataloader)
    train_ppl = torch.exp(train_epoch_loss)
    <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;<span class="hljs-subst">{epoch=}</span>: <span class="hljs-subst">{train_ppl=}</span> <span class="hljs-subst">{train_epoch_loss=}</span> <span class="hljs-subst">{eval_ppl=}</span> <span class="hljs-subst">{eval_epoch_loss=}</span>&quot;</span>)`}}),Le=new Re({}),Me=new y({props:{code:`from huggingface_hub import notebook_login

notebook_login()`,highlighted:`<span class="hljs-keyword">from</span> huggingface_hub <span class="hljs-keyword">import</span> notebook_login

notebook_login()`}}),Se=new y({props:{code:`peft_model_id = "your-name/bloomz-560m_PROMPT_TUNING_CAUSAL_LM"
model.push_to_hub("your-name/bloomz-560m_PROMPT_TUNING_CAUSAL_LM", use_auth_token=True)`,highlighted:`peft_model_id = <span class="hljs-string">&quot;your-name/bloomz-560m_PROMPT_TUNING_CAUSAL_LM&quot;</span>
model.push_to_hub(<span class="hljs-string">&quot;your-name/bloomz-560m_PROMPT_TUNING_CAUSAL_LM&quot;</span>, use_auth_token=<span class="hljs-literal">True</span>)`}}),Ne=new Re({}),Oe=new y({props:{code:`from peft import PeftModel, PeftConfig

peft_model_id = "stevhliu/bloomz-560m_PROMPT_TUNING_CAUSAL_LM"

config = PeftConfig.from_pretrained(peft_model_id)
model = AutoModelForCausalLM.from_pretrained(config.base_model_name_or_path)
model = PeftModel.from_pretrained(model, peft_model_id)`,highlighted:`<span class="hljs-keyword">from</span> peft <span class="hljs-keyword">import</span> PeftModel, PeftConfig

peft_model_id = <span class="hljs-string">&quot;stevhliu/bloomz-560m_PROMPT_TUNING_CAUSAL_LM&quot;</span>

config = PeftConfig.from_pretrained(peft_model_id)
model = AutoModelForCausalLM.from_pretrained(config.base_model_name_or_path)
model = PeftModel.from_pretrained(model, peft_model_id)`}}),Ie=new y({props:{code:`inputs = tokenizer(
    f'{text_column} : {"@nationalgridus I have no water and the bill is current and paid. Can you do something about this?"} Label : ',
    return_tensors="pt",
)`,highlighted:`inputs = tokenizer(
    <span class="hljs-string">f&#x27;<span class="hljs-subst">{text_column}</span> : <span class="hljs-subst">{<span class="hljs-string">&quot;@nationalgridus I have no water and the bill is current and paid. Can you do something about this?&quot;</span>}</span> Label : &#x27;</span>,
    return_tensors=<span class="hljs-string">&quot;pt&quot;</span>,
)`}}),Ue=new y({props:{code:`model.to(device)

with torch.no_grad():
    inputs = {k: v.to(device) for k, v in inputs.items()}
    outputs = model.generate(
        input_ids=inputs["input_ids"], attention_mask=inputs["attention_mask"], max_new_tokens=10, eos_token_id=3
    )
    print(tokenizer.batch_decode(outputs.detach().cpu().numpy(), skip_special_tokens=True))
[
    "Tweet text : @nationalgridus I have no water and the bill is current and paid. Can you do something about this? Label : complaint"
]`,highlighted:`model.to(device)

<span class="hljs-keyword">with</span> torch.no_grad():
    inputs = {k: v.to(device) <span class="hljs-keyword">for</span> k, v <span class="hljs-keyword">in</span> inputs.items()}
    outputs = model.generate(
        input_ids=inputs[<span class="hljs-string">&quot;input_ids&quot;</span>], attention_mask=inputs[<span class="hljs-string">&quot;attention_mask&quot;</span>], max_new_tokens=<span class="hljs-number">10</span>, eos_token_id=<span class="hljs-number">3</span>
    )
    <span class="hljs-built_in">print</span>(tokenizer.batch_decode(outputs.detach().cpu().numpy(), skip_special_tokens=<span class="hljs-literal">True</span>))
[
    <span class="hljs-string">&quot;Tweet text : @nationalgridus I have no water and the bill is current and paid. Can you do something about this? Label : complaint&quot;</span>
]`}}),{c(){k=l("meta"),X=u(),w=l("h1"),z=l("a"),U=l("span"),h(T.$$.fragment),L=u(),J=l("span"),Qa=s("Prompt tuning for causal language modeling"),Wt=u(),h(re.$$.fragment),Xt=u(),He=l("p"),Va=s("Prompting helps guide language model behavior by adding some input text specific to a task. Prompt tuning is an additive method for only training and updating the newly added prompt tokens to a pretrained model. This way, you can use one pretrained model whose weights are frozen, and train and update a smaller set of prompt parameters for each downstream task instead of fully finetuning a separate model. As models grow larger and larger, prompt tuning can be more efficient, and results are even better as model parameters scale."),Jt=u(),h(K.$$.fragment),Kt=u(),C=l("p"),Za=s("This guide will show you how to apply prompt tuning to train a "),ie=l("a"),it=l("code"),es=s("bloomz-560m"),ts=s(" model on the "),pt=l("code"),as=s("twitter_complaints"),ss=s(" subset of the "),pe=l("a"),os=s("RAFT"),ns=s(" dataset."),Qt=u(),Ge=l("p"),ls=s("Before you begin, make sure you have all the necessary libraries installed:"),Vt=u(),h(ue.$$.fragment),Zt=u(),F=l("h2"),Q=l("a"),ut=l("span"),h(de.$$.fragment),rs=u(),dt=l("span"),is=s("Setup"),ea=u(),M=l("p"),ps=s("Start by defining the model and tokenizer, the dataset and the dataset columns to train on, some training hyperparameters, and the "),Ye=l("a"),us=s("PromptTuningConfig"),ds=s(". The "),Be=l("a"),ms=s("PromptTuningConfig"),hs=s(" contains information about the task type, the text to initialize the prompt embedding, the number of virtual tokens, and the tokenizer to use:"),ta=u(),h(me.$$.fragment),aa=u(),R=l("h2"),V=l("a"),mt=l("span"),h(he.$$.fragment),_s=u(),ht=l("span"),cs=s("Load dataset"),sa=u(),j=l("p"),fs=s("For this guide, you\u2019ll load the "),_t=l("code"),gs=s("twitter_complaints"),bs=s(" subset of the "),_e=l("a"),ks=s("RAFT"),vs=s(" dataset. This subset contains tweets that are labeled either "),ct=l("code"),ws=s("complaint"),$s=s(" or "),ft=l("code"),ys=s("no complaint"),js=s(":"),oa=u(),h(ce.$$.fragment),na=u(),q=l("p"),qs=s("To make the "),gt=l("code"),Es=s("Label"),Ps=s(" column more readable, replace the "),bt=l("code"),xs=s("Label"),Ts=s(" value with the corresponding label text and store them in a "),kt=l("code"),zs=s("text_label"),Cs=s(" column. You can use the "),fe=l("a"),As=s("map"),Ls=s(" function to apply this change over the entire dataset in one step:"),la=u(),h(ge.$$.fragment),ra=u(),H=l("h2"),Z=l("a"),vt=l("span"),h(be.$$.fragment),Ms=u(),wt=l("span"),Ds=s("Preprocess dataset"),ia=u(),We=l("p"),Ss=s("Next, you\u2019ll setup a tokenizer; configure the appropriate padding token to use for padding sequences, and determine the maximum length of the tokenized labels:"),pa=u(),h(ke.$$.fragment),ua=u(),ee=l("p"),Ns=s("Create a "),$t=l("code"),Os=s("preprocess_function"),Is=s(" to:"),da=u(),E=l("ol"),yt=l("li"),Us=s("Tokenize the input text and labels."),Fs=u(),ve=l("li"),Rs=s("For each example in a batch, pad the labels with the tokenizers "),jt=l("code"),Hs=s("pad_token_id"),Gs=s("."),Ys=u(),we=l("li"),Bs=s("Concatenate the input text and labels into the "),qt=l("code"),Ws=s("model_inputs"),Xs=s("."),Js=u(),G=l("li"),Ks=s("Create a separate attention mask for "),Et=l("code"),Qs=s("labels"),Vs=s(" and "),Pt=l("code"),Zs=s("model_inputs"),eo=s("."),to=u(),$e=l("li"),ao=s("Loop through each example in the batch again to pad the input ids, labels, and attention mask to the "),xt=l("code"),so=s("max_length"),oo=s(" and convert them to PyTorch tensors."),ma=u(),h(ye.$$.fragment),ha=u(),D=l("p"),no=s("Use the "),je=l("a"),lo=s("map"),ro=s(" function to apply the "),Tt=l("code"),io=s("preprocess_function"),po=s(" to the entire dataset. You can remove the unprocessed columns since the model won\u2019t need them:"),_a=u(),h(qe.$$.fragment),ca=u(),P=l("p"),uo=s("Create a "),Ee=l("a"),zt=l("code"),mo=s("DataLoader"),ho=s(" from the "),Ct=l("code"),_o=s("train"),co=s(" and "),At=l("code"),fo=s("eval"),go=s(" datasets. Set "),Lt=l("code"),bo=s("pin_memory=True"),ko=s(" to speed up the data transfer to the GPU during training if the samples in your dataset are on a CPU."),fa=u(),h(Pe.$$.fragment),ga=u(),Y=l("h2"),te=l("a"),Mt=l("span"),h(xe.$$.fragment),vo=u(),Dt=l("span"),wo=s("Train"),ba=u(),Xe=l("p"),$o=s("You\u2019re almost ready to setup your model and start training!"),ka=u(),$=l("p"),yo=s("Initialize a base model from "),Te=l("a"),jo=s("AutoModelForCausalLM"),qo=s(", and pass it and "),St=l("code"),Eo=s("peft_config"),Po=s(" to the "),Nt=l("code"),xo=s("get_peft_model()"),To=s(" function to create a "),Je=l("a"),zo=s("PeftModel"),Co=s(". You can print the new "),Ke=l("a"),Ao=s("PeftModel"),Lo=s("\u2019s trainable parameters to see how much more efficient it is than training the full parameters of the original model!"),va=u(),h(ze.$$.fragment),wa=u(),Qe=l("p"),Mo=s("Setup an optimizer and learning rate scheduler:"),$a=u(),h(Ce.$$.fragment),ya=u(),Ve=l("p"),Do=s("Move the model to the GPU, then write a training loop to start training!"),ja=u(),h(Ae.$$.fragment),qa=u(),B=l("h2"),ae=l("a"),Ot=l("span"),h(Le.$$.fragment),So=u(),It=l("span"),No=s("Share model"),Ea=u(),Ze=l("p"),Oo=s("You can store and share your model on the Hub if you\u2019d like. Log in to your Hugging Face account and enter your token when prompted:"),Pa=u(),h(Me.$$.fragment),xa=u(),se=l("p"),Io=s("Use the "),De=l("a"),Uo=s("push_to_hub"),Fo=s(" function to upload your model to a model repository on the Hub:"),Ta=u(),h(Se.$$.fragment),za=u(),et=l("p"),Ro=s("Once the model is uploaded, you\u2019ll see the model file size is only 33.5kB! \u{1F90F}"),Ca=u(),W=l("h2"),oe=l("a"),Ut=l("span"),h(Ne.$$.fragment),Ho=u(),Ft=l("span"),Go=s("Inference"),Aa=u(),v=l("p"),Yo=s("Let\u2019s try the model on a sample input for inference. If you look at the repository you uploaded the model to, you\u2019ll see a "),Rt=l("code"),Bo=s("adapter_config.json"),Wo=s(" file. Load this file into "),tt=l("a"),Xo=s("PeftConfig"),Jo=s(" to specify the "),Ht=l("code"),Ko=s("peft_type"),Qo=s(" and "),Gt=l("code"),Vo=s("task_type"),Zo=s(". Then you can load the prompt tuned model weights, and the configuration into "),at=l("a"),en=s("from_pretrained()"),tn=s(" to create the "),st=l("a"),an=s("PeftModel"),sn=s(":"),La=u(),h(Oe.$$.fragment),Ma=u(),ot=l("p"),on=s("Grab a tweet and tokenize it:"),Da=u(),h(Ie.$$.fragment),Sa=u(),ne=l("p"),nn=s("Put the model on a GPU and "),Yt=l("em"),ln=s("generate"),rn=s(" the predicted label:"),Na=u(),h(Ue.$$.fragment),this.h()},l(e){const n=Tl('[data-svelte="svelte-1phssyn"]',document.head);k=r(n,"META",{name:!0,content:!0}),n.forEach(a),X=d(e),w=r(e,"H1",{class:!0});var Fe=i(w);z=r(Fe,"A",{id:!0,class:!0,href:!0});var pn=i(z);U=r(pn,"SPAN",{});var un=i(U);_(T.$$.fragment,un),un.forEach(a),pn.forEach(a),L=d(Fe),J=r(Fe,"SPAN",{});var dn=i(J);Qa=o(dn,"Prompt tuning for causal language modeling"),dn.forEach(a),Fe.forEach(a),Wt=d(e),_(re.$$.fragment,e),Xt=d(e),He=r(e,"P",{});var mn=i(He);Va=o(mn,"Prompting helps guide language model behavior by adding some input text specific to a task. Prompt tuning is an additive method for only training and updating the newly added prompt tokens to a pretrained model. This way, you can use one pretrained model whose weights are frozen, and train and update a smaller set of prompt parameters for each downstream task instead of fully finetuning a separate model. As models grow larger and larger, prompt tuning can be more efficient, and results are even better as model parameters scale."),mn.forEach(a),Jt=d(e),_(K.$$.fragment,e),Kt=d(e),C=r(e,"P",{});var le=i(C);Za=o(le,"This guide will show you how to apply prompt tuning to train a "),ie=r(le,"A",{href:!0,rel:!0});var hn=i(ie);it=r(hn,"CODE",{});var _n=i(it);es=o(_n,"bloomz-560m"),_n.forEach(a),hn.forEach(a),ts=o(le," model on the "),pt=r(le,"CODE",{});var cn=i(pt);as=o(cn,"twitter_complaints"),cn.forEach(a),ss=o(le," subset of the "),pe=r(le,"A",{href:!0,rel:!0});var fn=i(pe);os=o(fn,"RAFT"),fn.forEach(a),ns=o(le," dataset."),le.forEach(a),Qt=d(e),Ge=r(e,"P",{});var gn=i(Ge);ls=o(gn,"Before you begin, make sure you have all the necessary libraries installed:"),gn.forEach(a),Vt=d(e),_(ue.$$.fragment,e),Zt=d(e),F=r(e,"H2",{class:!0});var Ia=i(F);Q=r(Ia,"A",{id:!0,class:!0,href:!0});var bn=i(Q);ut=r(bn,"SPAN",{});var kn=i(ut);_(de.$$.fragment,kn),kn.forEach(a),bn.forEach(a),rs=d(Ia),dt=r(Ia,"SPAN",{});var vn=i(dt);is=o(vn,"Setup"),vn.forEach(a),Ia.forEach(a),ea=d(e),M=r(e,"P",{});var nt=i(M);ps=o(nt,"Start by defining the model and tokenizer, the dataset and the dataset columns to train on, some training hyperparameters, and the "),Ye=r(nt,"A",{href:!0});var wn=i(Ye);us=o(wn,"PromptTuningConfig"),wn.forEach(a),ds=o(nt,". The "),Be=r(nt,"A",{href:!0});var $n=i(Be);ms=o($n,"PromptTuningConfig"),$n.forEach(a),hs=o(nt," contains information about the task type, the text to initialize the prompt embedding, the number of virtual tokens, and the tokenizer to use:"),nt.forEach(a),ta=d(e),_(me.$$.fragment,e),aa=d(e),R=r(e,"H2",{class:!0});var Ua=i(R);V=r(Ua,"A",{id:!0,class:!0,href:!0});var yn=i(V);mt=r(yn,"SPAN",{});var jn=i(mt);_(he.$$.fragment,jn),jn.forEach(a),yn.forEach(a),_s=d(Ua),ht=r(Ua,"SPAN",{});var qn=i(ht);cs=o(qn,"Load dataset"),qn.forEach(a),Ua.forEach(a),sa=d(e),j=r(e,"P",{});var S=i(j);fs=o(S,"For this guide, you\u2019ll load the "),_t=r(S,"CODE",{});var En=i(_t);gs=o(En,"twitter_complaints"),En.forEach(a),bs=o(S," subset of the "),_e=r(S,"A",{href:!0,rel:!0});var Pn=i(_e);ks=o(Pn,"RAFT"),Pn.forEach(a),vs=o(S," dataset. This subset contains tweets that are labeled either "),ct=r(S,"CODE",{});var xn=i(ct);ws=o(xn,"complaint"),xn.forEach(a),$s=o(S," or "),ft=r(S,"CODE",{});var Tn=i(ft);ys=o(Tn,"no complaint"),Tn.forEach(a),js=o(S,":"),S.forEach(a),oa=d(e),_(ce.$$.fragment,e),na=d(e),q=r(e,"P",{});var N=i(q);qs=o(N,"To make the "),gt=r(N,"CODE",{});var zn=i(gt);Es=o(zn,"Label"),zn.forEach(a),Ps=o(N," column more readable, replace the "),bt=r(N,"CODE",{});var Cn=i(bt);xs=o(Cn,"Label"),Cn.forEach(a),Ts=o(N," value with the corresponding label text and store them in a "),kt=r(N,"CODE",{});var An=i(kt);zs=o(An,"text_label"),An.forEach(a),Cs=o(N," column. You can use the "),fe=r(N,"A",{href:!0,rel:!0});var Ln=i(fe);As=o(Ln,"map"),Ln.forEach(a),Ls=o(N," function to apply this change over the entire dataset in one step:"),N.forEach(a),la=d(e),_(ge.$$.fragment,e),ra=d(e),H=r(e,"H2",{class:!0});var Fa=i(H);Z=r(Fa,"A",{id:!0,class:!0,href:!0});var Mn=i(Z);vt=r(Mn,"SPAN",{});var Dn=i(vt);_(be.$$.fragment,Dn),Dn.forEach(a),Mn.forEach(a),Ms=d(Fa),wt=r(Fa,"SPAN",{});var Sn=i(wt);Ds=o(Sn,"Preprocess dataset"),Sn.forEach(a),Fa.forEach(a),ia=d(e),We=r(e,"P",{});var Nn=i(We);Ss=o(Nn,"Next, you\u2019ll setup a tokenizer; configure the appropriate padding token to use for padding sequences, and determine the maximum length of the tokenized labels:"),Nn.forEach(a),pa=d(e),_(ke.$$.fragment,e),ua=d(e),ee=r(e,"P",{});var Ra=i(ee);Ns=o(Ra,"Create a "),$t=r(Ra,"CODE",{});var On=i($t);Os=o(On,"preprocess_function"),On.forEach(a),Is=o(Ra," to:"),Ra.forEach(a),da=d(e),E=r(e,"OL",{});var O=i(E);yt=r(O,"LI",{});var In=i(yt);Us=o(In,"Tokenize the input text and labels."),In.forEach(a),Fs=d(O),ve=r(O,"LI",{});var Ha=i(ve);Rs=o(Ha,"For each example in a batch, pad the labels with the tokenizers "),jt=r(Ha,"CODE",{});var Un=i(jt);Hs=o(Un,"pad_token_id"),Un.forEach(a),Gs=o(Ha,"."),Ha.forEach(a),Ys=d(O),we=r(O,"LI",{});var Ga=i(we);Bs=o(Ga,"Concatenate the input text and labels into the "),qt=r(Ga,"CODE",{});var Fn=i(qt);Ws=o(Fn,"model_inputs"),Fn.forEach(a),Xs=o(Ga,"."),Ga.forEach(a),Js=d(O),G=r(O,"LI",{});var lt=i(G);Ks=o(lt,"Create a separate attention mask for "),Et=r(lt,"CODE",{});var Rn=i(Et);Qs=o(Rn,"labels"),Rn.forEach(a),Vs=o(lt," and "),Pt=r(lt,"CODE",{});var Hn=i(Pt);Zs=o(Hn,"model_inputs"),Hn.forEach(a),eo=o(lt,"."),lt.forEach(a),to=d(O),$e=r(O,"LI",{});var Ya=i($e);ao=o(Ya,"Loop through each example in the batch again to pad the input ids, labels, and attention mask to the "),xt=r(Ya,"CODE",{});var Gn=i(xt);so=o(Gn,"max_length"),Gn.forEach(a),oo=o(Ya," and convert them to PyTorch tensors."),Ya.forEach(a),O.forEach(a),ma=d(e),_(ye.$$.fragment,e),ha=d(e),D=r(e,"P",{});var rt=i(D);no=o(rt,"Use the "),je=r(rt,"A",{href:!0,rel:!0});var Yn=i(je);lo=o(Yn,"map"),Yn.forEach(a),ro=o(rt," function to apply the "),Tt=r(rt,"CODE",{});var Bn=i(Tt);io=o(Bn,"preprocess_function"),Bn.forEach(a),po=o(rt," to the entire dataset. You can remove the unprocessed columns since the model won\u2019t need them:"),rt.forEach(a),_a=d(e),_(qe.$$.fragment,e),ca=d(e),P=r(e,"P",{});var I=i(P);uo=o(I,"Create a "),Ee=r(I,"A",{href:!0,rel:!0});var Wn=i(Ee);zt=r(Wn,"CODE",{});var Xn=i(zt);mo=o(Xn,"DataLoader"),Xn.forEach(a),Wn.forEach(a),ho=o(I," from the "),Ct=r(I,"CODE",{});var Jn=i(Ct);_o=o(Jn,"train"),Jn.forEach(a),co=o(I," and "),At=r(I,"CODE",{});var Kn=i(At);fo=o(Kn,"eval"),Kn.forEach(a),go=o(I," datasets. Set "),Lt=r(I,"CODE",{});var Qn=i(Lt);bo=o(Qn,"pin_memory=True"),Qn.forEach(a),ko=o(I," to speed up the data transfer to the GPU during training if the samples in your dataset are on a CPU."),I.forEach(a),fa=d(e),_(Pe.$$.fragment,e),ga=d(e),Y=r(e,"H2",{class:!0});var Ba=i(Y);te=r(Ba,"A",{id:!0,class:!0,href:!0});var Vn=i(te);Mt=r(Vn,"SPAN",{});var Zn=i(Mt);_(xe.$$.fragment,Zn),Zn.forEach(a),Vn.forEach(a),vo=d(Ba),Dt=r(Ba,"SPAN",{});var el=i(Dt);wo=o(el,"Train"),el.forEach(a),Ba.forEach(a),ba=d(e),Xe=r(e,"P",{});var tl=i(Xe);$o=o(tl,"You\u2019re almost ready to setup your model and start training!"),tl.forEach(a),ka=d(e),$=r(e,"P",{});var A=i($);yo=o(A,"Initialize a base model from "),Te=r(A,"A",{href:!0,rel:!0});var al=i(Te);jo=o(al,"AutoModelForCausalLM"),al.forEach(a),qo=o(A,", and pass it and "),St=r(A,"CODE",{});var sl=i(St);Eo=o(sl,"peft_config"),sl.forEach(a),Po=o(A," to the "),Nt=r(A,"CODE",{});var ol=i(Nt);xo=o(ol,"get_peft_model()"),ol.forEach(a),To=o(A," function to create a "),Je=r(A,"A",{href:!0});var nl=i(Je);zo=o(nl,"PeftModel"),nl.forEach(a),Co=o(A,". You can print the new "),Ke=r(A,"A",{href:!0});var ll=i(Ke);Ao=o(ll,"PeftModel"),ll.forEach(a),Lo=o(A,"\u2019s trainable parameters to see how much more efficient it is than training the full parameters of the original model!"),A.forEach(a),va=d(e),_(ze.$$.fragment,e),wa=d(e),Qe=r(e,"P",{});var rl=i(Qe);Mo=o(rl,"Setup an optimizer and learning rate scheduler:"),rl.forEach(a),$a=d(e),_(Ce.$$.fragment,e),ya=d(e),Ve=r(e,"P",{});var il=i(Ve);Do=o(il,"Move the model to the GPU, then write a training loop to start training!"),il.forEach(a),ja=d(e),_(Ae.$$.fragment,e),qa=d(e),B=r(e,"H2",{class:!0});var Wa=i(B);ae=r(Wa,"A",{id:!0,class:!0,href:!0});var pl=i(ae);Ot=r(pl,"SPAN",{});var ul=i(Ot);_(Le.$$.fragment,ul),ul.forEach(a),pl.forEach(a),So=d(Wa),It=r(Wa,"SPAN",{});var dl=i(It);No=o(dl,"Share model"),dl.forEach(a),Wa.forEach(a),Ea=d(e),Ze=r(e,"P",{});var ml=i(Ze);Oo=o(ml,"You can store and share your model on the Hub if you\u2019d like. Log in to your Hugging Face account and enter your token when prompted:"),ml.forEach(a),Pa=d(e),_(Me.$$.fragment,e),xa=d(e),se=r(e,"P",{});var Xa=i(se);Io=o(Xa,"Use the "),De=r(Xa,"A",{href:!0,rel:!0});var hl=i(De);Uo=o(hl,"push_to_hub"),hl.forEach(a),Fo=o(Xa," function to upload your model to a model repository on the Hub:"),Xa.forEach(a),Ta=d(e),_(Se.$$.fragment,e),za=d(e),et=r(e,"P",{});var _l=i(et);Ro=o(_l,"Once the model is uploaded, you\u2019ll see the model file size is only 33.5kB! \u{1F90F}"),_l.forEach(a),Ca=d(e),W=r(e,"H2",{class:!0});var Ja=i(W);oe=r(Ja,"A",{id:!0,class:!0,href:!0});var cl=i(oe);Ut=r(cl,"SPAN",{});var fl=i(Ut);_(Ne.$$.fragment,fl),fl.forEach(a),cl.forEach(a),Ho=d(Ja),Ft=r(Ja,"SPAN",{});var gl=i(Ft);Go=o(gl,"Inference"),gl.forEach(a),Ja.forEach(a),Aa=d(e),v=r(e,"P",{});var x=i(v);Yo=o(x,"Let\u2019s try the model on a sample input for inference. If you look at the repository you uploaded the model to, you\u2019ll see a "),Rt=r(x,"CODE",{});var bl=i(Rt);Bo=o(bl,"adapter_config.json"),bl.forEach(a),Wo=o(x," file. Load this file into "),tt=r(x,"A",{href:!0});var kl=i(tt);Xo=o(kl,"PeftConfig"),kl.forEach(a),Jo=o(x," to specify the "),Ht=r(x,"CODE",{});var vl=i(Ht);Ko=o(vl,"peft_type"),vl.forEach(a),Qo=o(x," and "),Gt=r(x,"CODE",{});var wl=i(Gt);Vo=o(wl,"task_type"),wl.forEach(a),Zo=o(x,". Then you can load the prompt tuned model weights, and the configuration into "),at=r(x,"A",{href:!0});var $l=i(at);en=o($l,"from_pretrained()"),$l.forEach(a),tn=o(x," to create the "),st=r(x,"A",{href:!0});var yl=i(st);an=o(yl,"PeftModel"),yl.forEach(a),sn=o(x,":"),x.forEach(a),La=d(e),_(Oe.$$.fragment,e),Ma=d(e),ot=r(e,"P",{});var jl=i(ot);on=o(jl,"Grab a tweet and tokenize it:"),jl.forEach(a),Da=d(e),_(Ie.$$.fragment,e),Sa=d(e),ne=r(e,"P",{});var Ka=i(ne);nn=o(Ka,"Put the model on a GPU and "),Yt=r(Ka,"EM",{});var ql=i(Yt);ln=o(ql,"generate"),ql.forEach(a),rn=o(Ka," the predicted label:"),Ka.forEach(a),Na=d(e),_(Ue.$$.fragment,e),this.h()},h(){m(k,"name","hf:doc:metadata"),m(k,"content",JSON.stringify(Dl)),m(z,"id","prompt-tuning-for-causal-language-modeling"),m(z,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(z,"href","#prompt-tuning-for-causal-language-modeling"),m(w,"class","relative group"),m(ie,"href","https://huggingface.co/bigscience/bloomz-560m"),m(ie,"rel","nofollow"),m(pe,"href","https://huggingface.co/datasets/ought/raft"),m(pe,"rel","nofollow"),m(Q,"id","setup"),m(Q,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(Q,"href","#setup"),m(F,"class","relative group"),m(Ye,"href","/docs/peft/main/en/package_reference/tuners#peft.PromptTuningConfig"),m(Be,"href","/docs/peft/main/en/package_reference/tuners#peft.PromptTuningConfig"),m(V,"id","load-dataset"),m(V,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(V,"href","#load-dataset"),m(R,"class","relative group"),m(_e,"href","https://huggingface.co/datasets/ought/raft"),m(_e,"rel","nofollow"),m(fe,"href","https://huggingface.co/docs/datasets/main/en/package_reference/main_classes#datasets.Dataset.map"),m(fe,"rel","nofollow"),m(Z,"id","preprocess-dataset"),m(Z,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(Z,"href","#preprocess-dataset"),m(H,"class","relative group"),m(je,"href","https://huggingface.co/docs/datasets/main/en/package_reference/main_classes#datasets.Dataset.map"),m(je,"rel","nofollow"),m(Ee,"href","https://pytorch.org/docs/stable/data.html#torch.utils.data.DataLoader"),m(Ee,"rel","nofollow"),m(te,"id","train"),m(te,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(te,"href","#train"),m(Y,"class","relative group"),m(Te,"href","https://huggingface.co/docs/transformers/main/en/model_doc/auto#transformers.AutoModelForCausalLM"),m(Te,"rel","nofollow"),m(Je,"href","/docs/peft/main/en/package_reference/peft_model#peft.PeftModel"),m(Ke,"href","/docs/peft/main/en/package_reference/peft_model#peft.PeftModel"),m(ae,"id","share-model"),m(ae,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(ae,"href","#share-model"),m(B,"class","relative group"),m(De,"href","https://huggingface.co/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.push_to_hub"),m(De,"rel","nofollow"),m(oe,"id","inference"),m(oe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(oe,"href","#inference"),m(W,"class","relative group"),m(tt,"href","/docs/peft/main/en/package_reference/config#peft.PeftConfig"),m(at,"href","/docs/peft/main/en/package_reference/peft_model#peft.PeftModel.from_pretrained"),m(st,"href","/docs/peft/main/en/package_reference/peft_model#peft.PeftModel")},m(e,n){t(document.head,k),p(e,X,n),p(e,w,n),t(w,z),t(z,U),c(T,U,null),t(w,L),t(w,J),t(J,Qa),p(e,Wt,n),c(re,e,n),p(e,Xt,n),p(e,He,n),t(He,Va),p(e,Jt,n),c(K,e,n),p(e,Kt,n),p(e,C,n),t(C,Za),t(C,ie),t(ie,it),t(it,es),t(C,ts),t(C,pt),t(pt,as),t(C,ss),t(C,pe),t(pe,os),t(C,ns),p(e,Qt,n),p(e,Ge,n),t(Ge,ls),p(e,Vt,n),c(ue,e,n),p(e,Zt,n),p(e,F,n),t(F,Q),t(Q,ut),c(de,ut,null),t(F,rs),t(F,dt),t(dt,is),p(e,ea,n),p(e,M,n),t(M,ps),t(M,Ye),t(Ye,us),t(M,ds),t(M,Be),t(Be,ms),t(M,hs),p(e,ta,n),c(me,e,n),p(e,aa,n),p(e,R,n),t(R,V),t(V,mt),c(he,mt,null),t(R,_s),t(R,ht),t(ht,cs),p(e,sa,n),p(e,j,n),t(j,fs),t(j,_t),t(_t,gs),t(j,bs),t(j,_e),t(_e,ks),t(j,vs),t(j,ct),t(ct,ws),t(j,$s),t(j,ft),t(ft,ys),t(j,js),p(e,oa,n),c(ce,e,n),p(e,na,n),p(e,q,n),t(q,qs),t(q,gt),t(gt,Es),t(q,Ps),t(q,bt),t(bt,xs),t(q,Ts),t(q,kt),t(kt,zs),t(q,Cs),t(q,fe),t(fe,As),t(q,Ls),p(e,la,n),c(ge,e,n),p(e,ra,n),p(e,H,n),t(H,Z),t(Z,vt),c(be,vt,null),t(H,Ms),t(H,wt),t(wt,Ds),p(e,ia,n),p(e,We,n),t(We,Ss),p(e,pa,n),c(ke,e,n),p(e,ua,n),p(e,ee,n),t(ee,Ns),t(ee,$t),t($t,Os),t(ee,Is),p(e,da,n),p(e,E,n),t(E,yt),t(yt,Us),t(E,Fs),t(E,ve),t(ve,Rs),t(ve,jt),t(jt,Hs),t(ve,Gs),t(E,Ys),t(E,we),t(we,Bs),t(we,qt),t(qt,Ws),t(we,Xs),t(E,Js),t(E,G),t(G,Ks),t(G,Et),t(Et,Qs),t(G,Vs),t(G,Pt),t(Pt,Zs),t(G,eo),t(E,to),t(E,$e),t($e,ao),t($e,xt),t(xt,so),t($e,oo),p(e,ma,n),c(ye,e,n),p(e,ha,n),p(e,D,n),t(D,no),t(D,je),t(je,lo),t(D,ro),t(D,Tt),t(Tt,io),t(D,po),p(e,_a,n),c(qe,e,n),p(e,ca,n),p(e,P,n),t(P,uo),t(P,Ee),t(Ee,zt),t(zt,mo),t(P,ho),t(P,Ct),t(Ct,_o),t(P,co),t(P,At),t(At,fo),t(P,go),t(P,Lt),t(Lt,bo),t(P,ko),p(e,fa,n),c(Pe,e,n),p(e,ga,n),p(e,Y,n),t(Y,te),t(te,Mt),c(xe,Mt,null),t(Y,vo),t(Y,Dt),t(Dt,wo),p(e,ba,n),p(e,Xe,n),t(Xe,$o),p(e,ka,n),p(e,$,n),t($,yo),t($,Te),t(Te,jo),t($,qo),t($,St),t(St,Eo),t($,Po),t($,Nt),t(Nt,xo),t($,To),t($,Je),t(Je,zo),t($,Co),t($,Ke),t(Ke,Ao),t($,Lo),p(e,va,n),c(ze,e,n),p(e,wa,n),p(e,Qe,n),t(Qe,Mo),p(e,$a,n),c(Ce,e,n),p(e,ya,n),p(e,Ve,n),t(Ve,Do),p(e,ja,n),c(Ae,e,n),p(e,qa,n),p(e,B,n),t(B,ae),t(ae,Ot),c(Le,Ot,null),t(B,So),t(B,It),t(It,No),p(e,Ea,n),p(e,Ze,n),t(Ze,Oo),p(e,Pa,n),c(Me,e,n),p(e,xa,n),p(e,se,n),t(se,Io),t(se,De),t(De,Uo),t(se,Fo),p(e,Ta,n),c(Se,e,n),p(e,za,n),p(e,et,n),t(et,Ro),p(e,Ca,n),p(e,W,n),t(W,oe),t(oe,Ut),c(Ne,Ut,null),t(W,Ho),t(W,Ft),t(Ft,Go),p(e,Aa,n),p(e,v,n),t(v,Yo),t(v,Rt),t(Rt,Bo),t(v,Wo),t(v,tt),t(tt,Xo),t(v,Jo),t(v,Ht),t(Ht,Ko),t(v,Qo),t(v,Gt),t(Gt,Vo),t(v,Zo),t(v,at),t(at,en),t(v,tn),t(v,st),t(st,an),t(v,sn),p(e,La,n),c(Oe,e,n),p(e,Ma,n),p(e,ot,n),t(ot,on),p(e,Da,n),c(Ie,e,n),p(e,Sa,n),p(e,ne,n),t(ne,nn),t(ne,Yt),t(Yt,ln),t(ne,rn),p(e,Na,n),c(Ue,e,n),Oa=!0},p(e,[n]){const Fe={};n&2&&(Fe.$$scope={dirty:n,ctx:e}),K.$set(Fe)},i(e){Oa||(f(T.$$.fragment,e),f(re.$$.fragment,e),f(K.$$.fragment,e),f(ue.$$.fragment,e),f(de.$$.fragment,e),f(me.$$.fragment,e),f(he.$$.fragment,e),f(ce.$$.fragment,e),f(ge.$$.fragment,e),f(be.$$.fragment,e),f(ke.$$.fragment,e),f(ye.$$.fragment,e),f(qe.$$.fragment,e),f(Pe.$$.fragment,e),f(xe.$$.fragment,e),f(ze.$$.fragment,e),f(Ce.$$.fragment,e),f(Ae.$$.fragment,e),f(Le.$$.fragment,e),f(Me.$$.fragment,e),f(Se.$$.fragment,e),f(Ne.$$.fragment,e),f(Oe.$$.fragment,e),f(Ie.$$.fragment,e),f(Ue.$$.fragment,e),Oa=!0)},o(e){g(T.$$.fragment,e),g(re.$$.fragment,e),g(K.$$.fragment,e),g(ue.$$.fragment,e),g(de.$$.fragment,e),g(me.$$.fragment,e),g(he.$$.fragment,e),g(ce.$$.fragment,e),g(ge.$$.fragment,e),g(be.$$.fragment,e),g(ke.$$.fragment,e),g(ye.$$.fragment,e),g(qe.$$.fragment,e),g(Pe.$$.fragment,e),g(xe.$$.fragment,e),g(ze.$$.fragment,e),g(Ce.$$.fragment,e),g(Ae.$$.fragment,e),g(Le.$$.fragment,e),g(Me.$$.fragment,e),g(Se.$$.fragment,e),g(Ne.$$.fragment,e),g(Oe.$$.fragment,e),g(Ie.$$.fragment,e),g(Ue.$$.fragment,e),Oa=!1},d(e){a(k),e&&a(X),e&&a(w),b(T),e&&a(Wt),b(re,e),e&&a(Xt),e&&a(He),e&&a(Jt),b(K,e),e&&a(Kt),e&&a(C),e&&a(Qt),e&&a(Ge),e&&a(Vt),b(ue,e),e&&a(Zt),e&&a(F),b(de),e&&a(ea),e&&a(M),e&&a(ta),b(me,e),e&&a(aa),e&&a(R),b(he),e&&a(sa),e&&a(j),e&&a(oa),b(ce,e),e&&a(na),e&&a(q),e&&a(la),b(ge,e),e&&a(ra),e&&a(H),b(be),e&&a(ia),e&&a(We),e&&a(pa),b(ke,e),e&&a(ua),e&&a(ee),e&&a(da),e&&a(E),e&&a(ma),b(ye,e),e&&a(ha),e&&a(D),e&&a(_a),b(qe,e),e&&a(ca),e&&a(P),e&&a(fa),b(Pe,e),e&&a(ga),e&&a(Y),b(xe),e&&a(ba),e&&a(Xe),e&&a(ka),e&&a($),e&&a(va),b(ze,e),e&&a(wa),e&&a(Qe),e&&a($a),b(Ce,e),e&&a(ya),e&&a(Ve),e&&a(ja),b(Ae,e),e&&a(qa),e&&a(B),b(Le),e&&a(Ea),e&&a(Ze),e&&a(Pa),b(Me,e),e&&a(xa),e&&a(se),e&&a(Ta),b(Se,e),e&&a(za),e&&a(et),e&&a(Ca),e&&a(W),b(Ne),e&&a(Aa),e&&a(v),e&&a(La),b(Oe,e),e&&a(Ma),e&&a(ot),e&&a(Da),b(Ie,e),e&&a(Sa),e&&a(ne),e&&a(Na),b(Ue,e)}}}const Dl={local:"prompt-tuning-for-causal-language-modeling",sections:[{local:"setup",title:"Setup"},{local:"load-dataset",title:"Load dataset"},{local:"preprocess-dataset",title:"Preprocess dataset"},{local:"train",title:"Train"},{local:"share-model",title:"Share model"},{local:"inference",title:"Inference"}],title:"Prompt tuning for causal language modeling"};function Sl(Bt){return zl(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Rl extends El{constructor(k){super();Pl(this,k,Sl,Ml,xl,{})}}export{Rl as default,Dl as metadata};
